/*
  info.cpp
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include "info.h"

Info::Info(QWidget *parent, const char *name, WFlags f) :
	QLabel(parent, name, f)
{

	QLabel::hide();
	setFrameStyle(QFrame::Box | QFrame::Plain);
#ifdef QWS
	setFont(QFont("lcfont", 12));
#else
	setFont(QFont("gothic", 8));
#endif

	timer_id = -1;
}

void Info::dispInfo(QString const &str)
{
	stopTimer();

	setText(str);
	adjustSize();
	setGeometry(30, 10, width(), height());
	show();
	timer_id = startTimer(2000);
}

void Info::hide()
{
	stopTimer();
	QLabel::hide();
}

void Info::timerEvent(QTimerEvent *e)
{
	if(e->timerId() == timer_id)
		hide();
}

void Info::stopTimer()
{
	if(timer_id >= 0){
		killTimer(timer_id);
		timer_id = -1;
	}
}
