/*
  map.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAP_H__
#define __MAP_H__

#include <qpixmap.h>
#include <qpixmapcache.h>
#include <qcache.h>
#include <qimage.h>
#include "pos.h"

class Map
{
public:
	Map(int _max_down = 4);
	~Map();
	QPixmap &getPix();
	int loadPixmap(Pos &pos);
	void setMapPath(QString const &path);
	void setGamma(double value);

private:
	QString getPath(Pos &pos);

	QImage zoom(QImage *img, int i, Pos const &pos);
	void gammaCorrection(QImage *img);

	QPixmapCache cache;
	QCache<QImage> img_cache;

	QString base_path;
	QPixmap pix;

	int max_down;

	int gamma_table[256];
};

#endif // __MAP_H__
